// axios函数封装
var proxy = {
    host: 'http://192.168.1.3:5821'
};
console.log(axios.defaults);
axios.defaults.baseURL = api.webServiceRootURL;

var http = (function() {
    // get
    var getFuc = function(obj) {
        return new Promise(function(resolve, reject) {
            axios({
                    method: 'get',
                    // `url` 是用于请求的服务器 URL
                    url: obj.url,
                    params: obj.data || {},
                    // `timeout` 指定请求超时的毫秒数(0 表示无超时时间)
                    // 如果请求话费了超过 `timeout` 的时间，请求将被中断
                    timeout: 0,
                    // 处理跨域
                    proxy: proxy,

                    // `withCredentials` 表示跨域请求时是否需要使用凭证
                    withCredentials: false, // default

                    // `headers` 是即将被发送的自定义请求头
                    headers: {
                        'Content-Type': 'application/json'
                    },
                    responseType: 'json', // default
                    responseEncoding: 'utf8', // default
                })
                .then(function(response) {
                    resolve(response);
                })
                .catch(function(error) {
                    reject(error)
                });
        });
    }
    // post
    var postFuc = function(obj) {
        return new Promise(function(resolve, reject) {
            axios({
                    method: 'post',
                    // `url` 是用于请求的服务器 URL
                    url: obj.url,
                    params: obj.data || {},
                    // `timeout` 指定请求超时的毫秒数(0 表示无超时时间)
                    // 如果请求话费了超过 `timeout` 的时间，请求将被中断
                    timeout: 0,
                    // 处理跨域
                    proxy: proxy,

                    // `withCredentials` 表示跨域请求时是否需要使用凭证
                    withCredentials: false, // default

                    // `headers` 是即将被发送的自定义请求头
                    headers: {
                        'Content-Type': 'application/json'
                    },
                    responseType: 'json', // default
                    responseEncoding: 'utf8', // default
                })
                .then(function(response) {
                    resolve(response);
                })
                .catch(function(error) {
                    reject(error)
                });
        });
    }
    return {
        get: getFuc,
        post: postFuc
    }
})()